import 'package:flutter/material.dart';
import 'package:xcommonwidgets/xcommonwidgets.dart';
import 'package:xfxbase/XFDataItem.dart';

class XfxDropDown<T> extends XDropSearch {
  XfxDropDown(
    this.colsOfXFdataItemToShow, {
    Key? key,
    required super.itemSelected,
    required super.liItems,
    required super.label,
    required super.onChanged_ItemOfDD,
    super.label_Color,
    super.label_BackColor,
    super.background_Color,
    super.itemWidgetBuilder,
    super.clearBTN,
    super.itemAsString,
    super.onFind,
    super.focusColorOfDD,
    super.menu_SearchBox_Active,
    super.contentPadding,
    super.dropdownBuilder,
    super.item_TextStyle,
    super.item_TextAlignment,
    super.label_Style,
    super.autoValidateMode = AutovalidateMode.disabled,
    super.clearBTN_Active,
    super.clearBTN_IconSize,
    super.clearBTN_Padding,
    super.clearBTN_IconColor,
    super.clearBTN_Constraints,
    super.clearBTN_getValueForCLEAR,
    super.menu_BackGroundColor,
    super.menu_Title,
    super.menu_Title_Color,
    super.menu_Title_Style,
    super.menu_SearchBoxBorderANDtitle_Color,
    super.al_BackGroundColor,
    super.al_Title,
    super.al_Title_Color,
    super.al_Title_Style,
    super.al_SearchBox_Active,
    super.al_SearchBoxBorderANDtitle_Color,
    super.dropBTN,
    super.dropBTN_Padding,
    super.dropBTN_IconColor,
    super.dropBTN_IconSize = 18,
    super.dropBTN_Constraints,
    super.labelANDborder_Color,
    super.label_Behavior,
    super.propToShowInItems,
    super.dropDownMode,
    super.validator,
    super.filterFn,
    super.item_LabelColor,
    super.item_LabelStyle,
    super.item_BackgroundColor,
    super.width,
    super.label_OnTop = true,
  }) : super() {}

  final Iterable<XProp> colsOfXFdataItemToShow;

  @override
  XfxDropDown_State<T> createState() => XfxDropDown_State<T>();
}

class XfxDropDown_State<T> extends XDropSearchState<T> {
  ///legame con .. così sa come comporre il tostring con tutte le XProp indicate nel XF
  @override
  String itemAsString_internal(Object? value) {
    if (value is XFDataItem) {
      var str = "";
      (widget as XfxDropDown<T>).colsOfXFdataItemToShow.forEach((element) {
        str += (str.isEmpty ? "" : " ") + value[element.col_Name].toString();
      });
      return str;
    } else
      return super.itemAsString_internal(value);
  }
}
