import 'dart:typed_data';

import 'package:flutter/material.dart';
import 'package:xfxbase/XFDataItem.dart';

import 'XF_ELENCO/XElenco.dart';

class XTabItem {
  XElenco? xElencoToView;
  final String? schNameToOpen;
  final XFDataItem? itemClass;
  int idx;
  Widget? content;
  final String caption;
  String key;
  final Color? color_backGroundTab;
  final Color? color_backGroundTab_Activate;
  final Color? iconColor_Active;
  final Color? iconColor_Disabled;
  final Color? labelColor_Active;
  final Color? labelColor_Disabled;

  final IconData? icon;
  final bool? isViewed;
  final Uint8List? image_Icon;
  XTabItem(
    this.idx,
    this.caption,
    this.key, {
    this.itemClass,
    this.isViewed,
    this.xElencoToView,
    this.schNameToOpen,
    this.icon,
    this.image_Icon,
    this.content,
    this.color_backGroundTab,
    this.color_backGroundTab_Activate,
    this.iconColor_Active,
    this.iconColor_Disabled,
    this.labelColor_Active,
    this.labelColor_Disabled,
  });
}
